﻿function MGui(	structure_list_element_param,
				status_elements_param,
				characteristics_elements_param,
				segments_holder_element_param,
				materials_list_element_param,
				mods_holder_element_param,
				engine_choice_element_param,
				device_choice_element_param,
				battery_choice_element_p,
				weapon_choice_element_p,
				plate1_choice_element_p, 
				plate2_choice_element_p, 
				plate3_choice_element_p, 
				armor_shield_choice_element_p){
	this.selected_id_ = false;
	this._selected_element = false;
	this._selected_option = false;
	
	this.selected_mod_id = false;
	this.selected_mod_details_element = false;
	
	this.structure_list_element = structure_list_element_param;
	this.status_elements = status_elements_param;
	this.characteristics_elements = characteristics_elements_param;
	this.segments_holder_element = segments_holder_element_param;//элемент с сегментами
	this.materials_list_element=materials_list_element_param;
	this.mods_holder_element = mods_holder_element_param;
	this.engine_choice_element = engine_choice_element_param;
	this.device_choice_element = device_choice_element_param;
	this.battery_choice_element = battery_choice_element_p;
	this.weapon_choice_element = weapon_choice_element_p;
	this.plate1_choice_element = plate1_choice_element_p;
	this.plate2_choice_element = plate2_choice_element_p;
	this.plate3_choice_element = plate3_choice_element_p;
	this.armor_shield_choice_element = armor_shield_choice_element_p;
	
	for(var i=0; i<allowed_structures.length; i++){
		this.structure_list_element.append("<div value='"+i+"'>"+allowed_structures[i].attr[_name].value+"</div>");
	}
	for(var i=0; i<materials.length; i++){
		this.materials_list_element.append("<div value='"+i+"'>"+materials[i].attr[_name].value+"</div>");
	}
	for(var i=0;i<devices.length;i++){
		this.device_choice_element.append("<div value='"+i+"'>"+devices[i].attr[_name].value+"</div>");
	}
	for(var i=0;i<engines.length;i++){
		this.engine_choice_element.append("<div value='"+i+"'>"+engines[i].attr[_name].value+"</div>");
	}
	for(var i=0;i<batteries.length;i++){
		this.battery_choice_element.append("<div value='"+i+"'>"+batteries[i].attr[_name].value+"</div>");
	}
	for(var i=0;i<weapons.length;i++){
		this.weapon_choice_element.append("<div value='"+i+"'>"+weapons[i].device.attr[_name].value+"</div>");
	}
	for(var i=0;i<armorplates.length;i++){
		this.plate1_choice_element.append("<div value='"+i+"'>"+armorplates[i].name+"</div>");
		this.plate2_choice_element.append("<div value='"+i+"'>"+armorplates[i].name+"</div>");
		this.plate3_choice_element.append("<div value='"+i+"'>"+armorplates[i].name+"</div>");
		this.armor_shield_choice_element.append("<div value='"+i+"'>"+armorplates[i].name+"</div>");
	}
	
	this.segment_holder_elements = false;//список элементов-сегментов
	
}

MGui.prototype.show_bmd = function(bmd_p,devices_lib_p){
	if(bmd_p && devices_lib_p.length>0){
		var tl = devices_lib_p[bmd_p.gen_lnk];
		if(tl){
			var tbshe = $("#bmdhold");
			tbshe.empty();
			var tgn = tl.attr[_name].value + '(' + bmd_p.gen_lnk + ')';
			tbshe.append($("<p></p>").text(tgn));
			var tce = $("<div></div>");
			//engines_arr
			for(var i=0;i<bmd_p.engines_arr.length;i++){
				var ted = devices_lib_p[bmd_p.engines_arr[i]];
				if(ted)tce.append($("<p>")
					.append($("<input>").attr("type","checkbox").attr("checked","checked"))
					.append($("<span>").text(ted.attr[_name].value + ' ' + ted.description)));
			}
			tbshe.append(tce);
		}
	}
}

MGui.prototype.show_mods = function(){
	for(var i=0;i<mods.length;i++){
		var mh = this.get_holder("mod_holder").attr("id","mod_holder_"+i);
		mh.append($("<div></div>")
			.append($("<span></span>").addClass("mod_title").attr("mod_idx",i).text("> "+mods[i].name))
			.append(mod_toggle_button_template.clone().attr("mod_idx",i)));
		mh.append(this.get_mod_details(i));
		this.mods_holder_element.append(mh);
	}
}
MGui.prototype.get_mod_details = function(mod_idx_param){
	var i = mod_idx_param;
	var details = $("<ul></ul>").attr("id","mod_details_"+i).addClass("mod_details").addClass("hidden");
		for(var j=0;j<mods[i].operations.length;j++){
			var opn = mods[i].operations[j];
			var opn_translated = "";
			var opn_user = opn.user_input;
			switch(opn.type){
				case _multiplication: 
					opn_translated = opn.description +': '+(opn_user?'':opn.value); 
					break;
				case _summation: 
					opn_translated = opn.description +': '+(opn_user?'':opn.value); 
					break;
				case _replacement: 
					opn_translated = opn.description +': '+(opn_user?'':opn.value);
					break;
			}
			var detail = $("<li></li>");
			detail.append($("<span></span>").text(opn_translated));
			if(opn_user){
				detail.append(user_input_template.clone().val(opn.value));
			}
			details.append(detail);
		}
	return details;
}

MGui.prototype.show_device = function(device_link_param, segment_link_param, device_counter_param, functional_param, device_type_param, rk_p){
	var _id_;
	var ttitle = '', ttxt = '';
	var d_options = [];
	var tdi = get_original_device_index(device_link_param);
	switch(device_type_param){
		case _device:
			_id_ ="#devices_holder_"+segment_link_param; 
			var td = devices[tdi];
			ttitle = td.description; 
			ttxt = td.attr[_name].value + (td.composite_name?' ('+td.composite_name+' '+Number(device_counter_param+1)+')':'');
			d_options = td.options;
			break;
		case _engine:
			_id_ ="#engines_holder_"+segment_link_param; 
			var td = engines[tdi];
			ttitle = td.device.description; 
			ttxt = td.device.attr[_name].value+' '+ td.attr[_name].value;
			d_options = td.device.options;
			break;
		case _battery:
			_id_ ="#batteries_holder_"+segment_link_param; 
			var td = batteries[tdi];
			ttitle = td.device.description;
			ttxt = td.device.attr[_name].value+' '+ td.attr[_name].value;
			d_options = td.device.options;
			break;
		case _weapon:
			_id_ ="#weapons_holder_"+segment_link_param; 
			var td = weapons[tdi];
			ttitle = td.device.description;
			ttxt = td.device.description+' '+ td.device.attr[_name].value;
			d_options = td.device.options;
			break;
		case _armor1:
			_id_ ="#armor1_holder_"+segment_link_param; 
			var td = armor_plates_1[tdi];
			ttitle = td.description;
			ttxt = td.description+' '+ td.attr[_name].value+'-'+(rk_p-2);
			d_options = td.options;
			break;
		case _shield:
			_id_ ="#armor1_holder_"+segment_link_param; 
			var td = armor_shields[tdi];
			ttitle = td.description;
			ttxt = td.description+' '+ td.attr[_name].value;
			d_options = td.options;
			break;
		case _armor2:
			_id_ ="#armor1_holder_"+segment_link_param; 
			var td = armor_plates_2[tdi];
			ttitle = td.description;
			ttxt = td.description+' '+ td.attr[_name].value+'-'+(rk_p-1);
			d_options = td.options;
			break;
		case _armor3:
			_id_ ="#armor1_holder_"+segment_link_param; 
			var td = armor_plates_3[tdi];
			ttitle = td.description;
			ttxt = td.description+' '+ td.attr[_name].value+'-'+rk_p;
			d_options = td.options;
			break;
	}
	var toe = this.get_holder("device_options_holder");
	for(i=0;i<d_options.length;i++){
		var tco = d_options[i];
		var tdo = $("<div></div>")
			.addClass("d_option")
			.attr("dvc_idx",device_link_param)
			.attr("opn_idx",i)
			.attr("opt_idx",0)
			.attr("dev_set",'' + device_link_param + device_counter_param)
			.attr("seg_idx",segment_link_param)
			.text('['+tco[0].name+']');
		toe.append(tdo);
	}
	var dht = this.get_holder("device_holder");
	if (!functional_param) dht.addClass("nonfunctional");
	$(_id_)
		.append(dht
			.attr("id","device_" + device_link_param + device_counter_param)
			.attr("dev_idx",device_link_param)
			.append($("<span></span>")
				.attr("title",ttitle)
				.text(ttxt))
			.append(remove_button_template.clone()
				.attr("dvc_indx",device_link_param)
				.attr("sgmt_indx",segment_link_param)
				.attr("dev_el_indx",device_counter_param))
			.append(toe)
		);
}

MGui.prototype.redraw_segment_title = function(seg_param,seg_idx_param,fst_con_param){
	var shp = ' хиты:'+Math.ceil(Number(seg_param.attr[_segment_hp].value));
	var tce = $(".segment_icon[value="+seg_idx_param+"]",this.segments_holder_element);
	
	tce.text(seg_param.attr[_name].value + ":" + seg_param.attr[_occ_place].value +shp);
	if(fst_con_param){
		tce.addClass("failed");
	}else{
		tce.removeClass("failed");
	}
}

MGui.prototype.redraw_hit_points=function(segments_param){
	var empty_segments_number = Number.MAX_VALUE;
	if(segments_param.length>0){
		empty_segments_number = 0;
		for(var i=0; i<segments_param.length;i++){
			var curseg = segments_param[i];
			var csap = curseg.attr[_occ_place].value;
			if(csap<=0) empty_segments_number++;
			var fcp = true;
			if (curseg.supporting_segment>-1){
				var ssap = segments_param[curseg.supporting_segment].attr[_occ_place].value;
				fcp = csap>ssap;
			}else {
				fcp=false;
			}
			
			this.redraw_segment_title(segments_param[i],i,fcp);
		}
	}
	return empty_segments_number;
}
MGui.prototype.show_segments = function(segments_param){
	if(segments_param.length>0){
		this.segments_holder_element.empty();
		var sg_groups = [];
		for(var i=0; i<segments_param.length;i++){
			var shp = ' хиты:'+Number(segments_param[i].attr[_segment_hp].value);
			var cur_gr_nr = segments_param[i].attr[_segment_group].value;
			var cur_el = this.get_holder("segment_holder")
				.attr("id","segment_"+i)
				.append(this.get_holder("segment_button")
					.append(this.get_holder("segment_icon")
						.attr("value",i)
						.text(segments_param[i].attr[_name].value 
							+ ":" + segments_param[i].attr[_occ_place].value + shp)))
				.append(this.get_holder("devices_holder adholder")
					.attr("id","devices_holder_"+i)
					.attr("value",i))
				.append(this.get_holder("engines_holder adholder")
					.attr("id","engines_holder_"+i)
					.attr("value",i))
				.append(this.get_holder("batteries_holder adholder")
					.attr("id","batteries_holder_"+i)
					.attr("value",i))
				.append(this.get_holder("weapons_holder adholder")
					.attr("id","weapons_holder_"+i)
					.attr("value",i))
				.append(this.get_holder("armor_holder adholder")
					.attr("id","armor1_holder_"+i)
					.attr("value",i))
			if(sg_groups[cur_gr_nr]){
				sg_groups[cur_gr_nr].append(cur_el);
			}else{
				sg_groups[cur_gr_nr] = this.get_holder("segment_group").append(cur_el);
			}
		}
		for(var i in sg_groups) {
			if (!sg_groups.hasOwnProperty(i)) continue;
			this.segments_holder_element.append(sg_groups[i]);
			this.segments_holder_element.append(this.get_holder("separator"));
		}
		this.segment_holder_elements = $(".segment_holder");
	}
}

MGui.prototype.show_parameter = function(param_param, value_param){
	this.characteristics_elements[param_param].text(value_param);
}

MGui.prototype.show_status = function(status_element_param, status_param){
	this.status_elements[status_element_param][1-status_param].hide();
	this.status_elements[status_element_param][status_param].show();
}

MGui.prototype.unselect_menu = function(){
	if(this.selected_id_){
		this._selected_option.removeClass("selected_option");
		this._selected_element.removeClass("displayed");
		this._selected_element=false;
		this.selected_id_=false;
	}
}
MGui.prototype.select_menu = function(selected_option_param,selected_id_new_param){
	var selected_element_ = $('#'+selected_id_new_param);
	this.selected_id_=selected_id_new_param;
	this._selected_option = selected_option_param;
	this._selected_option.addClass("selected_option");
	this._selected_element = selected_element_;
	this._selected_element.addClass("displayed");
}
MGui.prototype.show_selected_choice = function(selected_option_){
	var selected_id_new = selected_option_.attr("value");
	if(this.selected_id_){
		if(this.selected_id_==selected_id_new){
			this.unselect_menu();
		}else{
			this.unselect_menu();
			this.select_menu(selected_option_,selected_id_new);
		}
	}else{
		this.select_menu(selected_option_,selected_id_new);
	}
}

MGui.prototype.select_mod_details = function(selected_mod_id_param,selected_mod_details_element_param){
	if(this.selected_mod_id===selected_mod_id_param){
		this.lever_class(this.selected_mod_details_element,"hidden");
		this.selected_mod_details_element = false;
		this.selected_mod_id = false;
	}else{
		if(!(this.selected_mod_id===false)) this.lever_class(this.selected_mod_details_element,"hidden");
		this.selected_mod_details_element = selected_mod_details_element_param;
		this.selected_mod_id = selected_mod_id_param;
		this.lever_class(selected_mod_details_element_param,"hidden");
	}
}
MGui.prototype.unselect_mod_details = function(){
	if (!(this.selected_mod_id===false)) this.select_mod_details(this.selected_mod_id,this.selected_mod_details_element);
}

MGui.prototype.lever_class = function(element_param, class_param){ 
	if(element_param.hasClass(class_param)) element_param.removeClass(class_param);
	else element_param.addClass(class_param);
}

MGui.prototype.show_system_message = function(text_param){
	$("#system_message").text(text_param);
}

MGui.prototype.get_holder = function(class_param){
	return $("<div></div>").addClass(class_param);
}